#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "net.h"
#include "tut.h"

#ifndef CHECK
#define CHECK 0
#endif /* CHECK */

/*
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <arpa/inet.h>
*/

static int echo_no_reply = 0;

static void tut_close_wait(int usfd, U16 mseq, U16 yseq,
			   struct sockaddr_in *yaddr);

static void tut_fin_wait(int usfd, U16 mseq, U16 yseq,
			 struct sockaddr_in *yaddr);

static int new_bind(int usfd);

U32 tut_updatekey(U32 key)
{
    return key * KEY1 + KEY2;
}

/* This encryption is not reliable */
int tut_encrypt(U32* key, unsigned char* buff, int n)
{
    unsigned char k[4];
    int i;

#if CHECK
    printf("##<-CRYPT(%x): ", key); xdump(buff, n); putchar('\n');
#endif

    k[0] = (*key & 0x000000ff);
    k[1] = ((*key & 0x0000ff00) >> 8);
    k[2] = ((*key & 0x00ff0000) >> 16);
    k[3] = ((*key & 0xff000000) >> 24);
    for(i = 0; i < n; i++)
    {
	buff[i] = (buff[i] ^ k[i % 4]);
    }
	
#if CHECK
    printf("##->CRYPT): "); xdump(buff, n); putchar('\n');
#endif

    *key = tut_updatekey(*key);
    return n;
}

int tut_decrypt(U32* key, unsigned char* buff, int n)
{
    return tut_encrypt(key, buff, n);
}

static struct sockaddr_in *sessino_yaddr;
void established(U32 key,
		 int rfd, int wfd, int usfd, struct sockaddr_in *yaddr,
		 U16 mseq, U16 yseq)
{
    int resend_cnt, cnt;
    fd_set fdset, orig_fdset;
    int nfds;
    int send_size, recv_size;
    unsigned long wait_usec_time;
    U16 recv_seq;		/* received seq number */
    U16 recv_ack;		/* received ack number */
    U32 recv_flags;		/* received flags */
    struct sockaddr_in recv_addr;
    int redirect_flag = TUT_NONE;
    U32 ikey, okey;
    int error_count = 0;

#if CHECK
	    puts("############################");
	    puts("## CONNECTION ESTABLISHED ##");
	    puts("############################");
#endif

    ikey = okey = key;

    sessino_yaddr = yaddr;
    nfds = va_init_fdset(&orig_fdset, rfd, usfd, -1);
    resend_cnt = 0;
    send_size = recv_size = 0;
    wait_usec_time = MAX_WAIT_USEC;
#if 1
    while(getppid() != 1) /* ӤˤʤäƤޤä exit  */
#else
    while(1)
#endif
    {
	unsigned long usec;

	if(resend_cnt > MAX_RESEND)
	    break;
	fdset = orig_fdset;
	cnt = tut_select(nfds, &fdset, wait_usec_time);
	if(cnt < 0)
	{
	    perror("select");
	    sleep(1);
	    continue;
	}

	if(cnt == 0)
	{
	    /* ॢ
	     * ѥåȤ
	     */
	    if(send_size == 0)
	    {
		/* ERQ ȯԤơ̿褬Ƥ뤫ɤ
		 * å롣
		 */
		if(echo_no_reply == 100)
		{
		    close(usfd); exit(1);
		}
		tut_packhdr(send_packet, 0, 0, TUT_ERQ);
		if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
		{
		    perror("sendto");
		    if(error_count++ > IGNORE_ERRORS)
		    {
			close(usfd);
			shutdown(rfd, 2);
			shutdown(wfd, 2);
			close(rfd); close(wfd); exit(1);
		    }
		}
		else
		    error_count = 0;

		echo_no_reply++;
#if CHECK
		printf("## Echo Reply Send(%d)\n", echo_no_reply);
#endif

		if(echo_no_reply >= 5)
		{
		    /* ̤ */
		    /* ʬ IP ɥ쥹åơ
		       ѹƤ顤usfd ľơbind 
		       rfd, wfd  127.0.0.1 Υ롼ץХåɥ쥹
		       ǺƤʤȰʸưʤ
		       if(IP ɥ쥹ѹ)
		       {
		       		usfd = new_bind(usfd);
				redirect_flag = TUT_RDR;
		       }
		       */
		}
		continue;
	    }

	    /* send_size > 0 */
	    if(sendto_in(usfd, send_packet, send_size, yaddr) < 0)
	    {
		perror("sendto");
		if(error_count++ > IGNORE_ERRORS)
		{
		    close(usfd);
		    shutdown(rfd, 2);
		    shutdown(wfd, 2);
		    close(rfd); close(wfd); exit(1);
		}
	    }
	    else
		error_count = 0;

	    resend_cnt++;
	    continue;
	}

	if(FD_ISSET(usfd, &fdset))
	{
#if CHECK
	    printf("mseq=%d yseq=%d\n", mseq, yseq);
#endif
	    recv_size = tut_recvfrom(usfd, recv_packet, MAXPACKETSIZE,
				     &recv_addr,
				     &recv_seq, &recv_ack, &recv_flags);
	}
	else
	    recv_size = 0;

	/* rfd 뤤ϡusfd ɤߤȤǡ¸ߤ롣
	 * recv_size > 0 ξϡusfd ѥåȤäƤ롣
	 *
	 * SYN ä顢SYN  ACK ֤
	 *
	 * FIN ä顢TUT_CLOSE_WAIT ֤ء
	 *
	 * Хåեġrfd ɤ߼ǽʤ顢
	 * Хåե rfd Υǡ롣
	 *
	 * ǡä顢ǡ ACK ֤
	 */

	if(recv_size > 0)
	{
	    if(IS_FLAG_SET(recv_flags, TUT_SYN))
	    {
		/* SYN äSYN  ACK ֤*/
		tut_packhdr(recv_packet, recv_ack, recv_seq + 1, TUT_ACK);
		if(sendto_in(usfd, recv_packet, HDRSIZE, yaddr) < 0)
		{
		    perror("sendto");
		    if(error_count++ > IGNORE_ERRORS)
		    {
			close(usfd);
			shutdown(rfd, 2);
			shutdown(wfd, 2);
			close(rfd); close(wfd); exit(1);
		    }
		}
		else
		    error_count = 0;
		continue;
	    }

	    if(IS_FLAG_SET(recv_flags, TUT_FIN))
	    {
		/* ̿ TUT_FIN_WAIT_1 ֤ܤƤ롣
		 * TUT_CLOSE_WAIT ֤ء
		 */
		shutdown(rfd, 2);
		shutdown(wfd, 2);
		close(rfd); close(wfd);
		tut_close_wait(usfd, mseq, recv_seq + 1, yaddr);
		/* NOT REACHED */
	    }
	}

	if(send_size == 0 && FD_ISSET(rfd, &fdset))
	{
	    int n;

	    resend_cnt = 0;
	    /* Хåե rfd Υǡ */
	    n = read(rfd, send_packet + HDRSIZE, DATSIZE);
	    if(n < 0)
	    {
		perror("read");
		close(usfd);
		shutdown(rfd, 2);
		shutdown(wfd, 2);
		close(rfd); close(wfd); exit(1);
	    }

	    if(n == 0)
	    {
		/* λ
		 * TUT_FIN_WAIT_1 
		 */
		shutdown(rfd, 2);
		shutdown(wfd, 2);
		close(rfd);
		close(wfd);
		tut_fin_wait(usfd, mseq, yseq, yaddr);
		/* NOT REACHED */
	    }

	    /* ǡɤ߹ǡ key ǰŹ沽
	       key ͤ򹹿 */
	    n = tut_encrypt(&ikey,
			    (unsigned char *)send_packet + HDRSIZE, n);

	    /* Ǹ˼äǡ ACK Ƥ */
	    tut_packhdr(send_packet, mseq++, yseq, TUT_ACK|redirect_flag);
	    wait_usec_time = INIT_WAIT_USEC;
	    send_size = n + HDRSIZE;
	    redirect_flag = TUT_NONE;

	    if(recv_size == 0) /* select  wait ˡƤ */
	    {
		if(sendto_in(usfd, send_packet, send_size, yaddr) < 0)
		{
		    perror("sendto");
		    if(error_count++ > IGNORE_ERRORS)
		    {
			close(usfd);
			shutdown(rfd, 2);
			shutdown(wfd, 2);
			close(rfd); close(wfd); exit(1);
		    }
		}
		else
		    error_count = 0;
	    }

	    /* send Хåե¸ߤΤǡrfd ɤߤȤʤ褦ˤ */
	    FD_CLR(rfd, &orig_fdset);
	    nfds = usfd + 1;
	}

	if(recv_size > 0) /* ѥåȤä */
	{
	    if(recv_ack == mseq &&
	       send_size > 0 &&
	       IS_FLAG_SET(recv_flags, TUT_ACK))
	    {
		/* ǡ ACK ä
		 * ߤ롣
		 */
		wait_usec_time = MAX_WAIT_USEC;
		send_size = 0;

		/* send ХåեΤǡrfd ɤߤȤ褦ˤ */
		FD_SET(rfd, &orig_fdset);
		if(rfd >= nfds)
		    nfds = rfd + 1;
		resend_cnt = 0;
	    }

	    if(recv_seq != yseq)
	    {
		/* Υѥå */

		if(recv_size > HDRSIZE)
		{
		    /* ˡäƤϤʤΤǡACK Τߤ֤ */
		    tut_packhdr(recv_packet, 0, recv_seq + 1, TUT_ACK);
		    if(sendto_in(usfd, recv_packet, HDRSIZE, yaddr) < 0)
		    {
			perror("sendto");
			if(error_count++ > IGNORE_ERRORS)
			{
			    close(usfd);
			    shutdown(rfd, 2);
			    shutdown(wfd, 2);
			    close(rfd); close(wfd); exit(1);
			}
		    }
		    else
			error_count = 0;
		}
		continue;
	    }

	    if(recv_size > HDRSIZE)
	    {
		/* wfd ٤ǡ¸ߤ */
		int n;

		n = tut_decrypt(&okey,
				(unsigned char *)recv_packet + HDRSIZE,
				recv_size - HDRSIZE);
		write(wfd, recv_packet + HDRSIZE, n);
		yseq++;	/* ΥѥåȤϼʤʤ */
		/* ACK ֤ */
		if(send_size == 0)
		{
		    /* ACK Τߤ֤Ф */
		    tut_packhdr(recv_packet, mseq, yseq, TUT_ACK);
		    if(sendto_in(usfd, recv_packet, HDRSIZE, yaddr) < 0)
		    {
			perror("sendto");
			if(error_count++ > IGNORE_ERRORS)
			{
			    close(usfd);
			    shutdown(rfd, 2);
			    shutdown(wfd, 2);
			    close(rfd); close(wfd); exit(1);
			}
		    }
		    else
			error_count = 0;
		}
		else
		{
		    /* ACK Ȱˡsend_packet 롣 */
		    /* redirect_flag ϡ */
		    pack(send_packet + 2, "nN", yseq, TUT_ACK);
		    if(sendto_in(usfd, send_packet, send_size, yaddr) < 0)
		    {
			perror("sendto");
			if(error_count++ > IGNORE_ERRORS)
			{
			    close(usfd);
			    shutdown(rfd, 2);
			    shutdown(wfd, 2);
			    close(rfd); close(wfd); exit(1);
			}
		    }
		    else
			error_count = 0;
		}
	    }
	}
    }
    shutdown(rfd, 2);
    shutdown(wfd, 2);
    close(rfd); close(wfd); close(usfd); exit(1);
}

int tut_recvfrom(int usfd, char* recv_packet, int maxsize,
		 struct sockaddr_in *from,
		 U16 *recv_seq, U16 *recv_ack, U32 *recv_flags)
{
    int recv_size;

    if((recv_size = recvfrom_in(usfd, recv_packet, maxsize, from)) < 0)
    {
	perror("recvfrom");
	close(usfd); exit(1);
    }

    if(recv_size < HDRSIZE)
	return 0;
    tut_unpackhdr(recv_packet, recv_seq, recv_ack, recv_flags);

#if CHECK
    printf("recv_size=%d recv_seq=%d recv_ack=%d flags=0x%x\n",
	   recv_size, *recv_seq, *recv_ack, *recv_flags);
#endif

    /* NOTE: Please CHECK Security hole!! */
    if(sessino_yaddr->sin_addr.s_addr != from->sin_addr.s_addr &&
       IS_FLAG_SET(*recv_flags, TUT_RDR))
	*sessino_yaddr = *from;

    if(IS_FLAG_SET(*recv_flags, TUT_ERQ))
    {
	/* ERQ äflags եɤ ERY ˤ
	 * ֤
	 */
	pack(recv_packet + 4, "N", TUT_ERY);
	if(sendto_in(usfd, recv_packet, recv_size, from) < 0)
	    perror("sendto");
	return 0;
    }

    if(IS_FLAG_SET(*recv_flags, TUT_ERY))
    {
	echo_no_reply = 0;
	return 0;
    }

    return recv_size;
}

static void tut_close_wait(int usfd, U16 mseq, U16 yseq,
			   struct sockaddr_in *yaddr)
{
    fd_set fdset, orig_fdset;
    int nfds, cnt;
    struct sockaddr_in recv_addr;
    U16 recv_seq;		/* received seq number */
    U16 recv_ack;		/* received ack number */
    U32 recv_flags;		/* received flags */
    int recv_size;

#if CHECK
    puts("###########################");
    puts("## CLOSE-WAIT");
    puts("###########################");
#endif

    /* CLOSE-WAIT */
    tut_packhdr(send_packet, mseq, yseq, TUT_ACK);
    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
    {
	perror("sendto");
	close(usfd); exit(1);
    }

    /* LAST-ACK */
    tut_packhdr(send_packet, mseq, yseq, TUT_ACK | TUT_FIN);
    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
    {
	perror("sendto");
	close(usfd); exit(1);
    }

    nfds = va_init_fdset(&orig_fdset, usfd, -1);
    while(1)
    {
	fdset = orig_fdset;
	cnt = tut_select(nfds, &fdset, 3 * MAX_WAIT_USEC);
	if(cnt < 0)
	{
	    perror("select");
	    close(usfd); exit(1);
	}
	if(cnt == 0)
	{
	    close(usfd); exit(0);
	}

#if CHECK
	printf("mseq=%d yseq=%d ", mseq, yseq);
#endif
	recv_size = tut_recvfrom(usfd, recv_packet, MAXPACKETSIZE,
				 &recv_addr, &recv_seq, &recv_ack, &recv_flags);

	if(recv_size == 0)
	    continue;

	if(yseq == recv_seq + 1 && IS_FLAG_SET(recv_flags, TUT_FIN))
	{
	    tut_packhdr(send_packet, mseq, yseq, TUT_ACK);
	    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
	    {
		perror("sendto");
		close(usfd); exit(1);
	    }
	    tut_packhdr(send_packet, mseq, yseq, TUT_ACK | TUT_FIN);
	    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
	    {
		perror("sendto");
		close(usfd); exit(1);
	    }

	    continue;
	}

	if(recv_ack == mseq + 1 && IS_FLAG_SET(recv_flags, TUT_ACK))
	{
	    close(usfd);
	    exit(0);
	}
    }
    /* NOT REACHED */
}

static void tut_fin_wait(int usfd, U16 mseq, U16 yseq,
			 struct sockaddr_in *yaddr)
{
    fd_set fdset, orig_fdset;
    int nfds, cnt, resend_cnt;
    struct sockaddr_in recv_addr;
    U16 recv_seq;		/* received seq number */
    U16 recv_ack;		/* received ack number */
    U32 recv_flags;		/* received flags */
    int recv_size;

#if CHECK
    puts("###########################");
    puts("## FIN-WAIT-1");
#endif

    /* FIN-WAIT-1 */
    tut_packhdr(send_packet, mseq++, yseq, TUT_ACK | TUT_FIN);
    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
    {
	perror("sendto");
	close(usfd); exit(1);
    }

#if CHECK
    puts("## FIN-WAIT-2");
    puts("###########################");
#endif

    /* FIN-WAIT-2 */
    resend_cnt = 0;
    nfds = va_init_fdset(&orig_fdset, usfd, -1);
    while(1)
    {
	fdset = orig_fdset;
	cnt = tut_select(nfds, &fdset, INIT_WAIT_USEC);

	if(cnt == 0)
	{
	    if(resend_cnt == 10)
	    {
		close(usfd); exit(1);
	    }

	    /* FIN ѥåȤκ */
	    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
	    {
		perror("sendto");
		close(usfd); exit(1);
	    }
	    resend_cnt++;
	    continue;
	}

#if CHECK
	printf("mseq=%d yseq=%d ", mseq, yseq);
#endif
	recv_size = tut_recvfrom(usfd, recv_packet, MAXPACKETSIZE,
				 &recv_addr, &recv_seq, &recv_ack, &recv_flags);

	if(recv_size == 0)
	    continue;

	if(mseq == recv_ack && yseq == recv_seq &&
	   IS_FLAG_SET(recv_flags, TUT_ACK))
	    break;
    }

#if CHECK
    puts("###########################");
    puts("## TIME-WAIT");
    puts("###########################");
#endif

    /* TIME-WAIT */
    while(1)
    {
	fdset = orig_fdset;
	cnt = tut_select(nfds, &fdset, 3 * MAX_WAIT_USEC);
	if(cnt == 0)
	{
	    close(usfd); exit(0);
	}

#if CHECK
	printf("mseq=%d yseq=%d\n", mseq, yseq);
#endif
	recv_size = tut_recvfrom(usfd, recv_packet, MAXPACKETSIZE,
				 &recv_addr, &recv_seq, &recv_ack, &recv_flags);

	if(recv_size == 0)
	    continue;

	if(mseq == recv_ack && yseq == recv_seq &&
	   IS_FLAG_SET(recv_flags, TUT_ACK | TUT_FIN))
	{
	    tut_packhdr(send_packet, recv_ack, recv_seq + 1, TUT_ACK);
	    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
	    {
		perror("sendto");
		close(usfd); exit(1);
	    }
	    if(sendto_in(usfd, send_packet, HDRSIZE, yaddr) < 0)
	    {
		perror("sendto");
		close(usfd); exit(1);
	    }
	}
    }
    /* NOT REACHED */
}

static int new_bind(int usfd)
{
    return usfd;
}
