#ifndef ___TUT_H_
#define ___TUT_H_

#include "config.h"

#define TUT_VERSION "1.3"

/* client ---> tu ³ TCP ݡ */
#define DEFAULT_TU_CONN_PORT 10124

/* tu <---> ut ³ UDP ݡ */
#define UU_CONN_PORT 10124

/* tu <---> ut ̿Ѥͽݡ */
#define MIN_UDP_PORT 10125
#define MAX_UDP_PORT 11000

#ifndef KEY1
#define KEY1 7873
#endif
#ifndef KEY2
#define KEY2 11
#endif

#define MAXPACKETSIZE 256
#define HDRSIZE        12
#define DATSIZE       (MAXPACKETSIZE-HDRSIZE)
#define INIT_WAIT_USEC 200000
#define MAX_WAIT_USEC 3000000
#define MAX_RESEND 1024
#define SPARESIZE 256
#define SECURE_UT 1
#define IGNORE_ERRORS 16
#define DEFAULT_TCP_PORT 23

#define TUT_NONE 0
#define TUT_ACK 0x01
#define TUT_SYN 0x02
#define TUT_FIN 0x04
#define TUT_RST 0x08
#define TUT_ERQ 0x10 /* ECHO REQUEST */
#define TUT_ERY 0x20 /* ECHO REPLY */
#define TUT_RDR 0x40 /* REDIRECT */

enum tut_status_t
{
    TUT_CLOSED,			/* 0 */
    TUT_SYN_SENT,		/* 1 */
    TUT_SYN_RECEIVED,		/* 2 */
    TUT_ESTABLISHED,		/* 3 */
    TUT_CLOSE_WAIT,		/* 4 */
    TUT_FIN_WAIT_1,		/* 5 */
    TUT_FIN_WAIT_2,		/* 6 */
    TUT_TIME_WAIT		/* 7 */
};

#define IS_FLAG_SET(check, flags) (((check) & (flags)) == (flags))

extern char recv_packet[];
extern char send_packet[];

/* utils.c */
int fdgetc(int fd);
void fdprintf(int fd, const char* fmt, VADCL);
void fdperror(int fd, const char* msg);
void tut_packhdr(char* packet, U16 seqno, U16 ackno, U32 flags);
void tut_unpackhdr(const char *packet, U16 *seqno, U16 *ackno, U32 *flags);
int wait_usec(unsigned long usec);
int fionread(int fd);
U32 rand8(void);
U32 rand32(void);
int readable(int fd);
int pack(char* buff, const char* format, VADCL);
int unpack(const char* data, const char* fmt, VADCL);
void xdump(const void* val, int size);
int tut_select(int maxfd, fd_set* rfds, unsigned long wait_usec_time);
int va_init_fdset(fd_set* fds, VADCL);
void daemon_init(void);

/* estab.c */
void established(U32 key,
		 int rfd, int wfd, int usfd, struct sockaddr_in *yaddr,
		 U16 mseq, U16 yseq);
int tut_recvfrom(int usfd, char* recv_packet, int maxsize,
		 struct sockaddr_in *from,
		 U16 *recv_seq, U16 *recv_ack, U32 *recv_flags);

#endif /* ___TUT_H_ */
